module PingableIpamPlugin
  module IpamExtensions
    extend ActiveSupport::Concern

    module Overrides
      module ClassMethods
        def new(type, *args)
          if type == ::IPAM::MODES[:pingable]
            ::IPAM::PingRandomDb.new(*args)
          else
            super
          end
        end
      end

      def self.prepended(base)
        class << base
          prepend ClassMethods
        end
      end
    end

    included do
      ::IPAM::MODES[:pingable] ||= N_('Random DB with ping')

      prepend Overrides
    end
  end
end
